// reseau.h

#ifndef RESEAU_H
#define RESEAU_H

#include <vector>


const int LARGEUR_IMAGE = 24;
const int HAUTEUR_IMAGE = 24;
const int LARGEUR_COUCHE_CACHEE = 6;
const int HAUTEUR_COUCHE_CACHEE = 6;

const int TAILLE_COUCHE_ENTREE =  LARGEUR_IMAGE * HAUTEUR_IMAGE; // Nombre de neurones de la couche d'entrée
const int TAILLE_COUCHE_CACHEE = LARGEUR_COUCHE_CACHEE * HAUTEUR_COUCHE_CACHEE;
const int TAILLE_COUCHE_SORTIE = 26; // Pour 26 lettres possibles

const int MAXNODES = TAILLE_COUCHE_ENTREE;

class Reseau
{
  struct Neurone
  {
    std::vector<float> poids; // Poids des connexions d'entrée
    float seuil;              /* threshhold input value        */
    float etat;               /* activation state value of node*/
  };
  std::vector<float> diff_sortie;
  std::vector<float> diff_cachee;
  float EPSILON;
public:
  std::vector<Neurone> unit[3];
  void init(int epsilon, int NMND[3]);
  void copie_image_entree(const float image[]);
  void maj_activation(int couche);
  void retro_propagation(const float resultat[]);
  int get_max_out_index() const;
  void set_epsilon(int epsilon);
};

#endif
